// Package client provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen/v2 version v2.1.0 DO NOT EDIT.
package client

import (
	"bytes"
	"context"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"strings"
)

// Defines values for GrantType.
const (
	DelegatedServiceConnection  GrantType = "delegatedServiceConnection"
	DelegatedServicePublication GrantType = "delegatedServicePublication"
	ServiceConnection           GrantType = "serviceConnection"
	ServicePublication          GrantType = "servicePublication"
)

// ContentHash The hash of the Content of a Contract
type ContentHash = string

// GrantType The type action of a Contract distribution
type GrantType string

// Input Object that contains the information for the auto-sign check
type Input struct {
	// ContractContentHash The hash of the Content of a Contract
	ContractContentHash ContentHash `json:"contract_content_hash"`
	GrantTypes          []GrantType `json:"grant_types"`
	PeerIds             []PeerID    `json:"peer_ids"`
}

// PeerID The ID of a Peer
type PeerID = string

// Result The result of a auto-sign check
type Result struct {
	// Allowed if 'true' the Contract should be signed
	Allowed bool `json:"allowed"`

	// Status An optional object that contains more information about a auto-sign check that has not been approved
	Status *struct {
		// Reason Contains the reason why the Contract should not be signed
		Reason string `json:"reason"`
	} `json:"status,omitempty"`
}

// ShouldAutoSignJSONBody defines parameters for ShouldAutoSign.
type ShouldAutoSignJSONBody struct {
	// Input Object that contains the information for the auto-sign check
	Input Input `json:"input"`
}

// ShouldAutoSignJSONRequestBody defines body for ShouldAutoSign for application/json ContentType.
type ShouldAutoSignJSONRequestBody ShouldAutoSignJSONBody

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// ShouldAutoSignWithBody request with any body
	ShouldAutoSignWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error)

	ShouldAutoSign(ctx context.Context, body ShouldAutoSignJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) ShouldAutoSignWithBody(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewShouldAutoSignRequestWithBody(c.Server, contentType, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

func (c *Client) ShouldAutoSign(ctx context.Context, body ShouldAutoSignJSONRequestBody, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewShouldAutoSignRequest(c.Server, body)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewShouldAutoSignRequest calls the generic ShouldAutoSign builder with application/json body
func NewShouldAutoSignRequest(server string, body ShouldAutoSignJSONRequestBody) (*http.Request, error) {
	var bodyReader io.Reader
	buf, err := json.Marshal(body)
	if err != nil {
		return nil, err
	}
	bodyReader = bytes.NewReader(buf)
	return NewShouldAutoSignRequestWithBody(server, "application/json", bodyReader)
}

// NewShouldAutoSignRequestWithBody generates requests for ShouldAutoSign with any type of body
func NewShouldAutoSignRequestWithBody(server string, contentType string, body io.Reader) (*http.Request, error) {
	var err error

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/")
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	req, err := http.NewRequest("POST", queryURL.String(), body)
	if err != nil {
		return nil, err
	}

	req.Header.Add("Content-Type", contentType)

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// ShouldAutoSignWithBodyWithResponse request with any body
	ShouldAutoSignWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*ShouldAutoSignResponse, error)

	ShouldAutoSignWithResponse(ctx context.Context, body ShouldAutoSignJSONRequestBody, reqEditors ...RequestEditorFn) (*ShouldAutoSignResponse, error)
}

type ShouldAutoSignResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *struct {
		// Result The result of a auto-sign check
		Result Result `json:"result"`
	}
}

// Status returns HTTPResponse.Status
func (r ShouldAutoSignResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r ShouldAutoSignResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// ShouldAutoSignWithBodyWithResponse request with arbitrary body returning *ShouldAutoSignResponse
func (c *ClientWithResponses) ShouldAutoSignWithBodyWithResponse(ctx context.Context, contentType string, body io.Reader, reqEditors ...RequestEditorFn) (*ShouldAutoSignResponse, error) {
	rsp, err := c.ShouldAutoSignWithBody(ctx, contentType, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseShouldAutoSignResponse(rsp)
}

func (c *ClientWithResponses) ShouldAutoSignWithResponse(ctx context.Context, body ShouldAutoSignJSONRequestBody, reqEditors ...RequestEditorFn) (*ShouldAutoSignResponse, error) {
	rsp, err := c.ShouldAutoSign(ctx, body, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseShouldAutoSignResponse(rsp)
}

// ParseShouldAutoSignResponse parses an HTTP response from a ShouldAutoSignWithResponse call
func ParseShouldAutoSignResponse(rsp *http.Response) (*ShouldAutoSignResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &ShouldAutoSignResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest struct {
			// Result The result of a auto-sign check
			Result Result `json:"result"`
		}
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	}

	return response, nil
}
